{------------------------------------------------------------------------------}
{
   Unit Name: muodot
   Purpose  : TFigure-luokka ja sen jlkelisi VespaCad-tyylisten
              piirto-ohjelmien kyttn.
   Author   : Vesa Lappalainen
   Date     : 24.10.1999
   Changed  : 30.10.1999/vl
               + perint vaihdettu TGraphicControl
               + ominaisuus Pen ja Brush otettu Canvaksesta
               + kolmio piirretty polygonina, jotta sen sisustakin tulee
                 vrjtty
               + override SetBounds jotta left & top voi muutella
                 ja samlla laskut siirretty SetDBounds-metodiin
               + metodi ZoomMove, joka samalla sek zoomaa ett siirt
               + Alustaan ominaisuus Orsi, joka huolehtii komponenteista
               + Alusta hoitelee automaattisesti DragDroppia
   Changed  : 06.11.1999/vl
               + AsString-property
               + ReadFromFile
               + WriteToFile

   Changed  : 19.11.1999/vl
               + nimen ksittely, jotta kappaleet voidaan tunnistaa
                 muutokset pasiassa TOrsi
               + Alustaan tuhoaminen (ja tsshn tuli mhlitty, kun
                 taulukkoa meni lpi vrinpin...) ja viivstetty tuhoaminen
                 (kill)
   Changed  : 03.11.2001/vl
               + CLX-knns
   Changed  : 13.11.2001/vl
               + korjattu keskenn yhteensopimattomat GetAsString ja
                 SetAsString (h ja w olivat vaihtaneet paikkansa)

   ToDo     : ks. vespacadf.pas
              - mieti onko jrke ett monista on TOrsi-komponentissa
              

   Komponentit:
     TFigure - kantaluokka yleiselle kuviolle.
                ominaisuudet:
                 x,y : double - kuvion keskipiste
                 w,h : double - kuvion koko                      SendMessage
                 Pen, Brush   - miten maalataan
                 AsString     - kuvione tiedot merkkijonona
                metodit:
                 Paint  - pit overridata perityss luokassa
                 zoom   - muutaa kuvion kokoa valitulla kertoimella
                 move   - muuttaa kuvion paikkaa valitulla kertoimella
                 ZoomMove - tekee molemmat em.
                 Assign - sijoittaa toisen kuvion
                 SetDBounds - asettaa kuvion koon ja paikan (reaalilukuna)
                 ExtractMy - erottaa merkkijonosta kuvion omat tiedot.
                             Pit overridta, jos luokkaan listn
                             uusia "talletettavia" ominaisuuksia
     TNelio  - piirt nelin
     TKolmio - piirt kolmion
     TOrsi   - tallettaa "mallikappaleina" TFiguresta perittyj olioita
                ominaisuudet:
                  SizeX - mink kokoinen kappale monistetaan X-suunnassa
                  SizeY - mink kokoinen kappale monistetaan Y-suunnassa
                  GenName - mit nimi annetaan geneerisesti kuvioille
                            ( GenName := 'a' => a0, a1, a2 jne...)
                metodit:
                  Monista - monistaa parametrina tuodun kuvion parametrina
                            tuodun komponentin lapseksi
                  CreateNew - luo luokan nimen perusteella uuden olion
                  Find    - etsii tietyn komponentin alustalta
                  
     TAlusta - piirtoalusta, johon voi pudotella TFiguren jlkelisi
                ominaisuudet:
                  Orsi - kuka monistaa pudotetun kappaleen
                         Orrelta vedetty kuvion monistuu raahauksessa, muut
                         vain siirtyvt pudotuspaikkaan.
                metodit:
                  ReadFromFile - lukee tekstitiedostosta talletetut kuviot
                  WriteToFile  - tallettaa tekstitiedostoon kuviot
                  ClearAll     - tuhoaa kaikki kuviot pois
                  Kill         - tuhoaa valitun kuvion viivstetysti, eli
                                 lhett itselleen tuhoamisviestin
                taphatumat:
                  OnInsert     - kun alustalle pudotetaan ja on jo listty
                                 uusi kuvio
                  OnMove       - kun kuvio on liikautettu uuteen paikkaan                                  

   Talletuksen idea:
    - TFigureen listn property: AsString, jonka saantimetodi GetAsString
      palauttaa kuvion intiimit tiedot merkkijonona,
      esim: '10.5,12.5,24.7,30.8' (eli esim. x,y,h,w)
    - vastaavasti asettamismetodi SetAsString tehdnkin parametrilistalla
      kutsumaan metodia ExtractMy(var s)
      josta metodia uudelleen kirjoitettaessa (override) jokainen voi ottaa
      "oman" osansa jonosta.
    - Talletusvaiheessa TAlusta:WriteToFile ky lpi kaikki pllns olevat
      muodot ja kirjoittaa tiedostoon
        writeln(f,fig.ClassName,'=',fig.AsString);
    - Lukuvaiheessa TAlusta.ReadFromFile lukee rivin kerrallaan
        Readln(f,s);
        luokannimi := Extract(s,'=');
    - pyydetn orrelta tt luokan nime vastaava uuden olion ilmentym
      (vhn kuten TOrsi.Monista on nyt, mutta luokan nimen perusteella).
      Eli orsi ky lpi kaikki pllns olevat muodot ja jos jollakin
      muodolla on sama luokan nimi, monistaa tllaisen olion.
    - kun olion ilmentym on saatu, asetetaan attribuutit tietysti
        muoto.AsString := s;
    - vastaavaa esimerkki voi katsoa mallista
        n:\kurssit\cpp\moniste\esim\olioalk\luokkalis\elain.pas


}
{------------------------------------------------------------------------------}

unit muodot;

interface
uses  Classes,
{$ifdef CLX}
   QT,QForms,QExtCtrls,QControls,QGraphics,
{$else}
   Windows,messages, extctrls,controls,graphics,
{$endif}
   Types;


{$ifdef CLX}
{$else}
const WM_KILLFIGURE = WM_USER + 151;
{$endif}

type

  TFigure = class(TGraphicControl)
  private
    Fx: double;
    Fy: double;
    Fw: double;
    Fh: double;
    procedure Seth(const Value: double); virtual;
    procedure Setw(const Value: double); virtual;
    procedure Setx(const Value: double); virtual;
    procedure Sety(const Value: double); virtual;
    procedure SetBrush(Value: TBrush);   virtual;
    procedure SetPen(const Value: TPen); virtual;
    procedure StyleChanged(Sender: TObject); virtual;
    function GetBrush: TBrush;               virtual;
    function GetPen: TPen;                   virtual;
  protected
    function GetAsString: string; virtual;
    procedure ExtractMy(var s:string); virtual;
    procedure SetAsString(const Value: string); virtual;
  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
    procedure zoom(f:double); virtual;
    procedure move(f:double); virtual;
    procedure ZoomMove(f:double); virtual;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure SetDBounds(nx,ny,nw,nh: double); virtual;
    procedure Assign(Source:TPersistent); override;
  published
    property x : double read Fx write Setx;
    property y : double read Fy write Sety;
    property h : double read Fh write Seth;
    property w : double read Fw write Setw;
    property Pen : TPen read GetPen write SetPen;
    property Brush : TBrush read GetBrush write SetBrush;
    property DragMode;
    property AsString : string read GetAsString write SetAsString;
  end;

  TFigureEvent = procedure(fig:TFigure) of Object;

  TKolmio = class(TFigure)
  public
    procedure Paint; override;
  end;

  TNelio = class(TFigure)
  public
    procedure Paint; override;
  end;

  TOrsi = class(TPanel)
  private
    FSizeX: double;
    FSizeY: double;
    FGenName: string;
    FGenCount : integer;
    function Find2(par: TWinControl; var s, claname,
      conname: string): TFigure;
    function Separate(var s,claname,conname:string): boolean;
  public
    constructor Create(AOwner:TComponent); override;
    function Monista(par:TWinControl;x,y:integer; f:TFigure):TFigure;
    function CreateNew(par:TWinControl;s:string) : TFigure;
    function Find(par:TWinControl;s:string) : TFigure;
    class function GetFigureString(fig:TFigure) : string;
  published
    property SizeX:double read FSizeX write FSizeX;
    property SizeY:double read FSizeY write FSizeY;
    property GenName:string read FGenName write FGenName;
  end;

  TAlusta = class(TPanel)
  private
    FOrsi: TOrsi;
    FOnMove: TFigureEvent;
    FOnInsert: TFigureEvent;
  public
    procedure DragDrop(Source: TObject; X, Y: Integer); override;
    procedure DragOver(Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean); override;
    procedure SetOrsi(const Value: TOrsi); virtual;
{$ifdef CLX}

{$else}
    procedure WmKillFigure(var msg:TMessage); message WM_KILLFIGURE;
{$endif}
  public
    constructor Create(AOwner:TComponent); override;
    procedure zoom(f:double); virtual;
    procedure ReadFromFile(const filename:string);  virtual;
    procedure WriteToFile(const filename:string='');  virtual;
    procedure ClearAll; virtual;
    procedure Kill(fig:TFigure); virtual;
  published
    property Orsi : TOrsi read FOrsi write SetOrsi;
    property OnInsert : TFigureEvent read FOnInsert write FOnInsert;
    property OnMove : TFigureEvent read FOnMove write FOnMove;
  end;


procedure Register;

implementation
uses sysutils, kdouble;

procedure Register;
begin
 RegisterComponents('GKO', [TKolmio,TNelio,TAlusta,TOrsi]);
end;

{------------------------------------------------------------------------------}
{ TFigure }
procedure TFigure.Assign(Source:TPersistent);
var fig: TFigure;
begin
  if not ( Source is TFigure ) then begin
    inherited Assign(Source);
    exit;
  end;  
  fig := TFigure(Source);
  Parent := fig.Parent;
  SetDBounds(fig.x,fig.y,fig.w,fig.h);
  Pen := fig.Pen;
  Brush := fig.Brush;
  DragMode := fig.DragMode;
  Hint := fig.Hint;
  Tag := fig.Tag;
end;

constructor TFigure.Create(AOwner: TComponent);
begin
  inherited;
  Pen.OnChange := StyleChanged;
  Brush.OnChange := StyleChanged;
  DragMode := dmAutomatic;
end;

destructor TFigure.Destroy;
begin
  inherited;
end;

procedure TFigure.ExtractMy(var s: string);
begin
  SetDBounds(ExtractDouble(s,',',x),
             ExtractDouble(s,',',y),
             ExtractDouble(s,',',w),
             ExtractDouble(s,',',h));
  Pen.Color := ExtractInt(s,',',Pen.Color);
  Brush.Color := ExtractInt(s,',',Brush.Color);
end;

function TFigure.GetAsString: string;
begin
  Result := Format('%3.2f,%3.2f,%3.2f,%3.2f,$%6.6x,$%6.6x',
                   [x,y,h,w,Pen.Color,Brush.Color]);
end;

function TFigure.GetBrush: TBrush;
begin
  Result := Canvas.Brush;
end;

function TFigure.GetPen: TPen;
begin
  Result := Canvas.Pen;
end;

procedure TFigure.move(f: double);
begin
  SetDBounds(x*f,y*f,w,h);
end;

procedure TFigure.Paint;
begin
  inherited;
end;

procedure TFigure.SetAsString(const Value: string);
var s:string;
begin
  s := Value;
  ExtractMy(s);
end;

procedure TFigure.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  if ( csLoading in ComponentState ) then exit; // arvot tulevat kyll x,y,h,w
  if ( ALeft <> Round(x-w/2) ) then Fx := ALeft + w/2;
  if ( ATop <> Round(y-h/2) ) then Fy := ATop + h/2;
  if ( AWidth <> Round(w) ) then Fw := AWidth;
  if ( ATop <> Round(h) ) then Fh := AHeight;
  inherited;
end;

procedure TFigure.SetBrush(Value: TBrush);
begin
  Canvas.Brush := Value;
end;

procedure TFigure.SetDBounds(nx, ny, nw, nh: double);
begin
  Fx := nx;
  Fy := ny;
  Fw := nw;
  Fh := nh;
  inherited SetBounds(Round(x-w/2),Round(y-h/2),Round(w),Round(h));
end;

procedure TFigure.Seth(const Value: double);
begin
  SetDBounds(x,y,w,Value);
end;

procedure TFigure.SetPen(const Value: TPen);
begin
  Canvas.Pen := Value;
end;

procedure TFigure.Setw(const Value: double);
begin
  SetDBounds(x,y,Value,h);
end;

procedure TFigure.Setx(const Value: double);
begin
  SetDBounds(Value,y,w,h);
end;

procedure TFigure.Sety(const Value: double);
begin
  SetDBounds(x,Value,w,h);
end;

procedure TFigure.StyleChanged(Sender: TObject);
begin
  Invalidate;
end;


procedure TFigure.zoom(f: double);
begin
  SetDBounds(x,y,w*f,h*f);
end;

procedure TFigure.ZoomMove(f:double);
begin
  SetDBounds(x*f,y*f,w*f,w*f);
end;

{------------------------------------------------------------------------------}
{ TKolmio }

procedure TKolmio.Paint;
var sivut : array[0..2] of TPoint;
begin
  inherited;
  sivut[0].x := 0;           sivut[0].y := Height-1;
  sivut[1].x := Width-1;     sivut[1].y := Height-1;
  sivut[2].x := Width div 2; sivut[2].y := 0;
  Canvas.Polygon(sivut);
end;

{------------------------------------------------------------------------------}
{ TNelio }

procedure TNelio.Paint;
begin
  inherited;
  Canvas.Rectangle(0,0,Width-1,Height-1);
end;

{------------------------------------------------------------------------------}
{ TAlusta }

procedure TAlusta.zoom(f: double);
var i:integer; c : TControl; fig : TFigure;
begin
  for i:= 0 to ControlCount-1 do begin
    c := Controls[i];
    if not ( c is TFigure ) then continue;
    fig := TFigure(c);
    fig.ZoomMove(f);
  end;
end;

constructor TAlusta.Create(AOwner: TComponent);
begin
  inherited;
end;

procedure TAlusta.SetOrsi(const Value: TOrsi);
begin
  FOrsi := Value;
end;

procedure TAlusta.DragOver(Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := False;
  if ( Source is TFigure ) then Accept := true;
  if Assigned(OnDragOver) then
  begin
    Accept := True;
    OnDragOver(Self, Source, X, Y, State, Accept);
  end;
end;

procedure TAlusta.DragDrop(Source: TObject; X, Y: Integer);
var fig,newfig : TFigure;
begin
  if not ( Source is TFigure ) then exit;
  fig := TFigure(Source);
  if ( fig.Parent = Orsi ) and ( Orsi <> nil ) then begin
    newfig := Orsi.Monista(self,x,y,fig);
    if ( Assigned(OnInsert) ) then OnInsert(newfig);
  end
  else begin
    fig.x := x;
    fig.y := y;
    fig.Parent := self;
    if ( Assigned(OnMove) ) then OnMove(fig);
  end;
  inherited;

end;

procedure TAlusta.ReadFromFile(const filename: string);
var f:TextFile; s:string;
begin
  if ( Orsi = nil ) then exit;
  ClearAll;
  AssignFile(f,filename);
  Reset(f);
  while not Eof(f) do begin
    Readln(f,s);
    Orsi.CreateNew(self,s);
  end;
  Close(f);
end;

procedure TAlusta.WriteToFile(const filename: string);
var f:TextFile;
    i:integer; c : TControl; fig : TFigure;
begin
  AssignFile(f,filename);
  ReWrite(f);
  for i:= 0 to ControlCount-1 do begin
    c := Controls[i];
    if not ( c is TFigure ) then continue;
    fig := TFigure(c);
    writeln(f,TOrsi.GetFigureString(fig));
  end;
  Close(f);
end;

procedure TAlusta.ClearAll;
var i:integer; c : TControl;
begin
  i := 0;
  while i < ControlCount do begin
    c := Controls[i];
    if ( c is TFigure ) then c.Free
    else inc(i);
  end;
end;

procedure TAlusta.Kill(fig: TFigure);
begin
{$ifdef CLX}
  QApplication_postEvent(Application.Handle, QCustomEvent_create(QEventType_CMRelease, fig));
{$else}
  PostMessage(Handle,WM_KILLFIGURE,0,dword(fig));
{$endif}
end;

{$ifdef CLX}

{$else}
procedure TAlusta.WmKillFigure(var msg: TMessage);
var i:integer; ctr : TControl;
begin
  ctr := TControl(msg.LParam);
  for i:=0 to ControlCount-1 do begin
    if ( Controls[i] = ctr ) then begin
      Controls[i].Free;
      exit;
    end;
  end;
end;
{$endif}

{------------------------------------------------------------------------------}
{ TOrsi }

constructor TOrsi.Create(AOwner: TComponent);
begin
  inherited;
  SizeX := 20;
  SizeY := 20;
  GenName := 'A';
end;


function TOrsi.Separate(var s,claname,conname:string):boolean;
var cn:integer;cns : string;
begin
  Result := false;
  conname := ExtractString(s,'=','');
  if ( conname < '                  ' ) then exit;
  claname := ExtractString(conname,':','');
  cns := copy(conname,Length(GenName)+1,100);

  cn := StrToIntDef(cns,0);
  if ( cn >= FGenCount ) and
     ( UpperCase(GenName) = UpperCase(Copy(conname,1,Length(GenName))) ) then
        FGenCount := cn+1;

  Result := true;
end;

function TOrsi.Find2(par: TWinControl; var s,claname,conname : string): TFigure;
var i:integer; c : TControl; upname : string;
begin
  Result := nil;
  if not Separate(s,claname,conname) then exit;

  upname := UpperCase(conname);
  for i:=0 to par.ControlCount-1 do begin
    if ( UpperCase(par.Controls[i].Name) = upname ) then begin
      c:= par.Controls[i];
      if ( c is TFigure ) then Result := TFigure(c);
      Exit;
    end;
  end;

//  c := par.FindChildControl(conname);  // Ei toimintu jostakin syyst

end;

function TOrsi.Find(par: TWinControl; s: string): TFigure;
var claname,conname : string;
begin
  Result := Find2(par,s,claname,conname);
end;


function TOrsi.CreateNew(par:TWinControl;s: string): TFigure;
var i:integer; c : TControl; fig : TFigure; claname,conname : string;
begin
  Result := Find2(par,s,claname,conname);

  if ( Result <> nil ) then begin  // MOV if component allready exist
    if ( s > '               ' ) then Result.AsString := s;
    exit;
  end;

  for i:= 0 to ControlCount-1 do begin
    c := Controls[i];
    if not ( c is TFigure ) then continue;
    fig := TFigure(c);
    if ( fig.ClassName <> claname ) then continue;
    Result := TFigure(fig.NewInstance);
    Result.Create(par);
    Result.AsString := s;
    Result.Parent := par;
    Result.Name := conname;
    Exit;
  end;
end;

class function TOrsi.GetFigureString(fig: TFigure): string;
begin
  Result := fig.ClassName + ':' + fig.Name + '=' + fig.AsString;
end;

function TOrsi.Monista(par:TWinControl;x, y: integer; f: TFigure):TFigure;
var uusi : TFigure;
begin
  uusi := TFigure(f.NewInstance);
  uusi.Create(par);
  uusi.Assign(f);
  uusi.Parent := par;
  uusi.SetDBounds(x,y,SizeX,SizeY);
  uusi.Name := GenName+IntToStr(FGenCount);
  inc(FGenCount);
  Result := uusi;
end;


end.
